GuiCommand: Name: Reinforcement StraightRebar MenuLocation: 3D/BIM , Reinforcement tools , Straight Rebar Workbenches: Reinforcement_Workbench, BIM_Workbench Version: 0.17 SeeAlso:
Reinforcement StraightRebar
Description
The Reinforcement StraightRebar tool allows the user to create a set of straight reinforcing bars inside an Arch Structure object.
This tool is part of the Reinforcement Workbench, an external workbench that can be installed with the Addon Manager.
![](https://raw.githubusercontent.com/FreeCAD/FreeCAD-documentation/master/wiki/images/Arch_Rebar_Straight_example.png)
Usage
-
Select any face of a previously created
Arch Structure object.
-
Then select
Straight Rebar from the rebar tools.
-
A task panel will pop-out on the left side of the screen as shown below.
-
Select the desired orientation.
-
Give the inputs like \'Front cover\', \'Right side cover\', \'Left side cover\', \'Bottom cover\' and \'Diameter\' of the rebar.
-
Select the mode of distribution either \'Amount\' or \'Spacing\'.
-
If spacing is selected, a user can also opt for custom spacing.
-
Pick Selected Faceis used to verify or change the face for rebar distribution.
-
Click OK or Apply to generate the rebars.
-
Click Cancel to exit the task panel.
![](https://raw.githubusercontent.com/FreeCAD/FreeCAD-documentation/master/wiki/images/StraightRebarDialog.png)
Properties
-
Orientation: It decides the orientation of the rebar (like a bottom, top, right and left).
-
Front Cover: The distance between rebar and selected face.
-
Right Cover: The distance between the right end of the rebar to right face of the structure.
-
Left Cover: The distance between the left end of the rebar to the left face of the structure.
-
Cover along: These property facilities the user to specify either top or bottom cover.
-
Bottom Cover: The distance between rebar from the bottom face of the structure.
-
Top Cover: The distance between rebar from the top face of the structure.
-
Amount: The amount of rebars.
-
Spacing: The distance between the axes of each bar.
Scripting
See also:
Arch API, Reinforcement API and FreeCAD Scripting Basics.
The Reinforcement StraightRebar tool can be used in macros and from the Python console by using the following function:
Rebar = makeStraightRebar(f_cover, coverAlong, rt_cover, lb_cover,
diameter, amount_spacing_check, amount_spacing_value, orientation="Horizontal",
structure=None, facename=None)
-
Creates a
Rebar
object from the givenstructure
, which is an Arch Structure, andfacename
, which is a face of that structure.- If no
structure
norfacename
are given, it will take the user selected face as input.
- If no
-
f_cover
,coverAlong
,rt_cover
, andlb_cover
are inner offset distances for the rebar elements with respect to the faces of the structure.-
f_cover
is the frontal cover offset.
-
coverAlong
is a tuple
(position, value)
that defines the offset value in one position (top, bottom, left, right) depending on theorientation
. -
rt_cover
is either the right or the top cover offset, depending on the value of
coverAlong
andorientation
. -
lb_cover
is either the left or the bottom cover offset, depending on the value of
coverAlong
andorientation
.
-
-
diameter
is the diameter of the reinforcement bars inside the structure. -
amount_spacing_check
if it isTrue
it will create as many reinforcement bars as given byamount_spacing_value
; if it isFalse
it will create reinforcement bars separated by the numerical value ofamount_spacing_value
. -
amount_spacing_value
specifies the number of reinforcement bars, or the value of the separation between them, depending onamount_spacing_check
. -
orientation
specifies the orientation of the rebar; it can be"Horizontal"
or"Vertical"
.
Depending on the orientation of the rebar, the function can be called in two general ways by setting coverAlong
appropriately.
The rebar is horizontal
Rebar = makeStraightRebar(f_cover, ("Top Side", value), right_cover, left_cover, ...)
Rebar = makeStraightRebar(f_cover, ("Bottom Side", value), right_cover, left_cover, ...)
-
coverAlong
is a tuple with either a"Top Side"
or a"Bottom Side"
offsetvalue
. -
In this case
rt_cover
refers to theright_cover
offset, andlb_cover
refers to theleft_cover
offset.
The rebar is vertical
Rebar = makeStraightRebar(f_cover, ("Left Side", value), top_cover, bottom_cover, ...)
Rebar = makeStraightRebar(f_cover, ("Right Side", value), top_cover, bottom_cover, ...)
-
coverAlong
is a tuple with either a"Left Side"
or a"Right Side"
offsetvalue
. -
In this case
rt_cover
refers to thetop_cover
offset, andlb_cover
refers to thebottom_cover
offset.
Example horizontal
import Arch, Draft, StraightRebar
Structure = Arch.makeStructure(length=1000, width=1000, height=400)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()
Rebar = StraightRebar.makeStraightRebar(50, ("Bottom Side", 20), 100, 100,
12, True, 5, "Horizontal", Structure, "Face4")
Rebar.ViewObject.ShapeColor = (0.9, 0.0, 0.0)
Rebar2 = StraightRebar.makeStraightRebar(50, ("Bottom Side", 50), 100, 100,
12, True, 5, "Horizontal", Structure, "Face6")
Rebar2.ViewObject.ShapeColor = (0.0, 0.0, 0.9)
Example vertical
import Arch, Draft, StraightRebar
Structure2 = Arch.makeStructure(length=1000, width=1000, height=400)
Structure2.ViewObject.Transparency = 80
Draft.move(Structure2, FreeCAD.Vector(1500, 0, 0))
FreeCAD.ActiveDocument.recompute()
Rebar3 = StraightRebar.makeStraightRebar(50, ("Left Side", 20), 100, 100,
12, True, 5, "Vertical", Structure2, "Face4")
Rebar3.ViewObject.ShapeColor = (0.9, 0.5, 0.0)
Rebar4 = StraightRebar.makeStraightRebar(50, ("Left Side", 50), 100, 100,
12, True, 5, "Vertical", Structure2, "Face6")
Rebar4.ViewObject.ShapeColor = (0.0, 0.5, 0.5)
Edition of rebar
You can change the properties of the rebar with the following function:
editStraightRebar(Rebar, f_cover, coverAlong, rt_cover, lb_cover,
diameter, amount_spacing_check, amount_spacing_value, orientation,
structure=None, facename=None)
-
Rebar
is a previously createdStraightRebar
object. -
The other parameters are the same as required by the
makeStraightRebar()
function. -
structure
andfacename
may be omitted so that the rebar stays in the original structure.
Example:
import StraightRebar
StraightRebar.editStraightRebar(Rebar, 50, ("Top Side", 20), 100, 100,
24, True, 7, "Horizontal")
StraightRebar.editStraightRebar(Rebar2, 50, ("Top Side", 50), 100, 100,
24, True, 7, "Horizontal")
StraightRebar.editStraightRebar(Rebar3, 50, ("Right Side", 20), 100, 100,
24, True, 7, "Vertical")
StraightRebar.editStraightRebar(Rebar4, 50, ("Right Side", 50), 100, 100,
24, True, 7, "Vertical")
⏵ documentation index > External_Command_Reference > Reinforcement > BIM > Reinforcement StraightRebar
This page is retrieved from https://github.com/FreeCAD/FreeCAD-documentation/blob/main/wiki/Reinforcement_StraightRebar.md